unit Main;
//несколько примеров на использование системной
//функции ShellExecute()

interface

uses SysUtils, Forms, StdCtrls, LResources;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonTextFile: TButton;
    Memo1: TMemo;
    ButtonList: TButton;
    ButtonWeb: TButton;
    ButtonEMail: TButton;
    ButtonWP: TButton;
    ComboBox1: TComboBox;
    ButtonHtmlFile: TButton;
    Label1: TLabel;
    procedure ButtonClick(Sender: TObject);
    procedure ButtonListClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation


uses
  ShellExecuteUnit; //содержит ф-цию ShellExecute(), необходимые для ее
  //работы константы и вспомогательную ф-цию для работы с ошибками.

procedure TForm1.ButtonListClick(Sender: TObject);
//вывод описаний возвращаемых ShellExecute() значений
var
  I: Integer;
begin
  with Memo1.Lines do
  begin
    clear;
    Add('Список описаний возвращаемых значений (до 40) ShellExecute():');
    Add('____________________________________________________________');
    Add('');
    for I := 0 to 40 do
    Add('Если вернулось '+ IntToStr(I) + ' тогда ' + ErrorCodeToDescript(I));
  end;
end;


procedure TForm1.ButtonClick(Sender: TObject);
var
  ShellExecuteValue: Cardinal;
  ShowState: Integer;
begin
  //выбор из ComboBox флагов режима отображения окна
  ShowState:=SW_SHOW;//инициализация
  with ComboBox1 do  //тип показа окна
  if Text = 'SW_SHOW' then ShowState:=SW_SHOW else
  if Text = 'SW_SHOWNORMAL' then ShowState:=SW_SHOWNORMAL else
  if Text = 'SW_SHOWMINIMIZED' then ShowState:=SW_SHOWMINIMIZED else
  if Text = 'SW_SHOWMAXIMIZED' then ShowState:=SW_SHOWMAXIMIZED else
  if Text = 'SW_SHOWNA' then ShowState:=SW_SHOWNA else
  if Text = 'SW_SHOWNOACTIVATE' then ShowState:=SW_SHOWNOACTIVATE else
  if Text = 'SW_SHOWMINNOACTIVE' then ShowState:=SW_SHOWMINNOACTIVE else
  if Text = 'SW_MAXIMIZE' then ShowState:=SW_MAXIMIZE else
  if Text = 'SW_MINIMIZE' then ShowState:=SW_MINIMIZE else
  if Text = 'SW_RESTORE' then ShowState:=SW_RESTORE else
  if Text = 'SW_HIDE' then ShowState:=SW_HIDE else
  if Text = 'SW_SHOWDEFAULT' then ShowState:=SW_SHOWDEFAULT else
  Text:='SW_SHOW';//по-умолчанию

  with Memo1.Lines do
  begin
    clear;
    Add('Ружим показа окна: ' + ComboBox1.Text);
    Add('Константа режима: ' + IntToStr(ShowState));

    //Пример запуска WordPad и открытия в нем файла.
    //Если это сделать с флагом SW_HIDE, то вернуть WordPad из скрытого
    //режима удасться только после перезагрузки компьютера (по крайней мере у
    //меня это было так). В коде далее такая ситуация предотвращается.
    if Sender = ButtonWP then
    If ShowState = SW_HIDE then
    begin
      Add('Не рекомендуется запуск WordPad с флагом SW_HIDE. ' +
      'Запуск проигнорирован.');
      exit;
    end
    else
    ShellExecuteValue:=ShellExecuteA(Handle,
                                     Nil,
                                     'wordpad', //приложение (WordPad.exe)
                                     'TestFile.txt',//параметр коммандной
                                     //строки (здесь - имя файла)
                                     'test_folder', //папка по-умолчанию
                                     //в данном примере находится в рабочем
                                     //каталоге программы
                                     ShowState);

    //открытие текстового файла в программе, зарегистрированной в ОС для этого
    //типа файлов (обычно это Блокнот).
    if Sender = ButtonTextFile then
    ShellExecuteValue:=ShellExecuteA(Handle,
                                     Nil,
                                     'TestFile.txt',
                                     Nil,
                                     'test_folder',
                                     ShowState);

    //вариант открытия локального html-файла.
    //у меня изменение флага не имело значения.
    if Sender = ButtonHtmlFile then
    ShellExecuteValue:=ShellExecuteA(Handle,
                                     'open',
                                     'test_folder\htmlFile.html',
                                     Nil,
                                     Nil,
                                     ShowState);

    //открытие интернет-адреса в браузере по-умолчанию. Флаг у меня не имел
    //значения.
    if Sender = ButtonWeb then
    ShellExecuteValue:=ShellExecuteA(Handle,
                                     Nil,
                                     'http://somesite.some',//некий сайт
                                     Nil,
                                     Nil,
                                     ShowState);

    //вариант запуска почтовой программы по-умолчанию с темой сообщения. Флаг
    //у меня игнорировался.
    if Sender = ButtonEMail then
    ShellExecuteValue:=ShellExecuteA(Handle,
                                     Nil,
                                     'mailto:some@some.some?subject=тема',
                                     Nil,
                                     Nil,
                                     ShowState);
    //Add(IntToStr(getlasterror));
    Add('ShellExecute()...');
    If ShellExecuteValue > 32
    then Add('OK (вернулось ' + IntToStr(ShellExecuteValue) + ')') {успех}
    else Add(ErrorCodeToDescript(ShellExecuteValue));{ошибка при < = 32}
  end;
end;



initialization
  {$i Main.lrs}

end.
