unit Main;
//    
// ShellExecute()   

interface

uses  SysUtils, Forms, StdCtrls, Classes, Controls,
      Windows, ShellApi; //windows  ShellApi -  ;
      // ShellExecute()  

type
  TForm1 = class(TForm)
    ButtonTextFile: TButton;
    Memo1: TMemo;
    ButtonList: TButton;
    ButtonWeb: TButton;
    ButtonEMail: TButton;
    ButtonWP: TButton;
    ComboBox1: TComboBox;
    ButtonHtmlFile: TButton;
    Label1: TLabel;
    procedure ButtonClick(Sender: TObject);
    procedure ButtonListClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function ErrorCodeToDescript(ErrorCode: Cardinal):String;
begin
 Result := 'No errors.';
 If ErrorCode > 32 then exit      // 
 else Result := 'Unknown error.'; // 
 case ErrorCode of
    0:                       Result:='The operating system is out of memory '
                             + 'or resources.';
    ERROR_FILE_NOT_FOUND:    Result:='The specified file was not found.';
    ERROR_PATH_NOT_FOUND:    Result:='The specified path was not found.';
    ERROR_BAD_FORMAT:        Result:='The .exe file is invalid (non-Microsoft '
                             + 'Win32 .exe or error in .exe image).';
    SE_ERR_ACCESSDENIED:     Result:='The operating system denied access to '
                             + 'the specified file.';
    SE_ERR_ASSOCINCOMPLETE:  Result:='The file name association is incomplete '
                             + 'or invalid.';
    SE_ERR_DDEBUSY:          Result:='The Dynamic Data Exchange (DDE) '
                             + 'transaction could not be completed because '
                             + 'other DDE transactions were being processed.';
    SE_ERR_DDEFAIL:          Result:='The DDE transaction failed.';
    SE_ERR_DDETIMEOUT:       Result:='The DDE transaction could not be '
                             + 'completed because the request timed out.';
    SE_ERR_DLLNOTFOUND:      Result:='The specified dynamic-link library (DLL) '
                             + 'was not found.';
    SE_ERR_NOASSOC:          Result:='There is no application associated with '
                             + 'the given file name extension. This error will '
                             + 'also be returned if you attempt to print a '
                             + 'file that is not printable.';
    SE_ERR_OOM:              Result:='There was not enough memory to complete '
                             + 'the operation.';
    SE_ERR_SHARE:            Result:='A sharing violation occurred.';
 end;
 Result := 'ERROR: ' + Result;
end;

procedure TForm1.ButtonListClick(Sender: TObject);
//   ShellExecute() 
var
  I: Integer;
begin
  with Memo1.Lines do
  begin
    clear;
    Add('    ( 40) ShellExecute():');
    Add('____________________________________________________________');
    Add('');
    for I := 0 to 40 do
    Add('  '+ IntToStr(I) + '  ' + ErrorCodeToDescript(I));
  end;
end;

procedure TForm1.ButtonClick(Sender: TObject);
var
  ShellExecuteValue: Cardinal;
  ShowState: Integer;
begin
  //  ComboBox    
  ShowState:=SW_SHOW;//
  with ComboBox1 do  //  
  if Text = 'SW_SHOW' then ShowState:=SW_SHOW else
  if Text = 'SW_SHOWNORMAL' then ShowState:=SW_SHOWNORMAL else
  if Text = 'SW_SHOWMINIMIZED' then ShowState:=SW_SHOWMINIMIZED else
  if Text = 'SW_SHOWMAXIMIZED' then ShowState:=SW_SHOWMAXIMIZED else
  if Text = 'SW_SHOWNA' then ShowState:=SW_SHOWNA else
  if Text = 'SW_SHOWNOACTIVATE' then ShowState:=SW_SHOWNOACTIVATE else
  if Text = 'SW_SHOWMINNOACTIVE' then ShowState:=SW_SHOWMINNOACTIVE else
  if Text = 'SW_MAXIMIZE' then ShowState:=SW_MAXIMIZE else
  if Text = 'SW_MINIMIZE' then ShowState:=SW_MINIMIZE else
  if Text = 'SW_RESTORE' then ShowState:=SW_RESTORE else
  if Text = 'SW_HIDE' then ShowState:=SW_HIDE else
  if Text = 'SW_SHOWDEFAULT' then ShowState:=SW_SHOWDEFAULT else
  Text:='SW_SHOW';//-

  with Memo1.Lines do    
  begin
    clear;
    Add('  : ' + ComboBox1.Text);
    Add(' : ' + IntToStr(ShowState));

    //  WordPad     .
    //     SW_HIDE,   WordPad  
    //      (   
    //   ).      .
    if Sender = ButtonWP then
    If ShowState = SW_HIDE then
    begin
      Add('   WordPad   SW_HIDE. ' +
      ' .');
      exit;
    end
    else
    ShellExecuteValue:=ShellExecute (Handle,
                                     Nil,
                                     'wordpad', // (WordPad.exe)
                                     'TestFile.txt',// 
                                     // ( -  )
                                     'test_folder', // -
                                     //     
                                     // 
                                     ShowState);

    //    ,     
    //  (  ).
    if Sender = ButtonTextFile then
    ShellExecuteValue:=ShellExecute (Handle,
                                     Nil,
                                     'TestFile.txt',
                                     Nil,
                                     'test_folder',
                                     ShowState);

    //   html-.
    //      .
    if Sender = ButtonHtmlFile then
    ShellExecuteValue:=ShellExecute (Handle,
                                     'open',
                                     'test_folder\htmlFile.html',
                                     Nil,
                                     Nil,
                                     ShowState);

    // -   -.     
    //.
    if Sender = ButtonWeb then
    ShellExecuteValue:=ShellExecute (Handle,
                                     Nil,
                                     'http://somesite.some',// 
                                     Nil,
                                     Nil,
                                     ShowState);

    //    -   . 
    //  .
    if Sender = ButtonEMail then
    ShellExecuteValue:=ShellExecute (Handle,
                                     Nil,
                                     'mailto:some@some.some?subject=',
                                     Nil,
                                     Nil,
                                     ShowState);
    //Add(IntToStr(getlasterror));
    Add('ShellExecute()...');
    If ShellExecuteValue > 32
    then Add('OK ( ' + IntToStr(ShellExecuteValue) + ')') {}
    else Add(ErrorCodeToDescript(ShellExecuteValue));{  < = 32}
  end;
//:
//     ShellExecuteA(),    
//shellapi.      Ansi- ShellExecute().
//  Unicode - ShellExecuteW().    PChar(=PAnsiChar) 
// PWideChar.
end;



end.
