unit Main;
//несколько примеров на использование системной
//функции ShellExecute()

interface

uses SysUtils, Forms, StdCtrls, LResources,
     Windows, ShellApi; //windows и ShellApi - стандартные модули;
     //содержат ShellExecute() и константы;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonTextFile: TButton;
    Memo1: TMemo;
    ButtonList: TButton;
    ButtonWeb: TButton;
    ButtonEMail: TButton;
    ButtonWP: TButton;
    ComboBox1: TComboBox;
    ButtonHtmlFile: TButton;
    Label1: TLabel;
    procedure ButtonClick(Sender: TObject);
    procedure ButtonListClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

function ErrorCodeToDescript(ErrorCode: Cardinal):String;
begin
 Result := 'No errors.';
 If ErrorCode > 32 then exit      //нет ошибок
 else Result := 'Unknown error.'; //начальное значение
 case ErrorCode of
    0:                       Result:='The operating system is out of memory '
                             + 'or resources.';
    ERROR_FILE_NOT_FOUND:    Result:='The specified file was not found.';
    ERROR_PATH_NOT_FOUND:    Result:='The specified path was not found.';
    ERROR_BAD_FORMAT:        Result:='The .exe file is invalid (non-Microsoft '
                             + 'Win32® .exe or error in .exe image).';
    SE_ERR_ACCESSDENIED:     Result:='The operating system denied access to '
                             + 'the specified file.';
    SE_ERR_ASSOCINCOMPLETE:  Result:='The file name association is incomplete '
                             + 'or invalid.';
    SE_ERR_DDEBUSY:          Result:='The Dynamic Data Exchange (DDE) '
                             + 'transaction could not be completed because '
                             + 'other DDE transactions were being processed.';
    SE_ERR_DDEFAIL:          Result:='The DDE transaction failed.';
    SE_ERR_DDETIMEOUT:       Result:='The DDE transaction could not be '
                             + 'completed because the request timed out.';
    SE_ERR_DLLNOTFOUND:      Result:='The specified dynamic-link library (DLL) '
                             + 'was not found.';
    SE_ERR_NOASSOC:          Result:='There is no application associated with '
                             + 'the given file name extension. This error will '
                             + 'also be returned if you attempt to print a '
                             + 'file that is not printable.';
    SE_ERR_OOM:              Result:='There was not enough memory to complete '
                             + 'the operation.';
    SE_ERR_SHARE:            Result:='A sharing violation occurred.';
 end;
 Result := 'ERROR: ' + Result;
end;

procedure TForm1.ButtonListClick(Sender: TObject);
//вывод описаний возвращаемых ShellExecute() значений
var
  I: Integer;
begin
  with Memo1.Lines do
  begin
    clear;
    Add('Список описаний возвращаемых значений (до 40) ShellExecute():');
    Add('____________________________________________________________');
    Add('');
    for I := 0 to 40 do
    Add('Если вернулось '+ IntToStr(I) + ' тогда ' + ErrorCodeToDescript(I));
  end;
end;


procedure TForm1.ButtonClick(Sender: TObject);
var
  ShellExecuteValue: Cardinal;
  ShowState: Integer;
begin
  //выбор из ComboBox флагов режима отображения окна
  ShowState:=SW_SHOW;//инициализация
  with ComboBox1 do  //тип показа окна
  if Text = 'SW_SHOW' then ShowState:=SW_SHOW else
  if Text = 'SW_SHOWNORMAL' then ShowState:=SW_SHOWNORMAL else
  if Text = 'SW_SHOWMINIMIZED' then ShowState:=SW_SHOWMINIMIZED else
  if Text = 'SW_SHOWMAXIMIZED' then ShowState:=SW_SHOWMAXIMIZED else
  if Text = 'SW_SHOWNA' then ShowState:=SW_SHOWNA else
  if Text = 'SW_SHOWNOACTIVATE' then ShowState:=SW_SHOWNOACTIVATE else
  if Text = 'SW_SHOWMINNOACTIVE' then ShowState:=SW_SHOWMINNOACTIVE else
  if Text = 'SW_MAXIMIZE' then ShowState:=SW_MAXIMIZE else
  if Text = 'SW_MINIMIZE' then ShowState:=SW_MINIMIZE else
  if Text = 'SW_RESTORE' then ShowState:=SW_RESTORE else
  if Text = 'SW_HIDE' then ShowState:=SW_HIDE else
  if Text = 'SW_SHOWDEFAULT' then ShowState:=SW_SHOWDEFAULT else
  Text:='SW_SHOW';//по-умолчанию

  with Memo1.Lines do
  begin
    clear;
    Add('Ружим показа окна: ' + ComboBox1.Text);
    Add('Константа режима: ' + IntToStr(ShowState));

    //Пример запуска WordPad и открытия в нем файла.
    //Если это сделать с флагом SW_HIDE, то вернуть WordPad из скрытого
    //режима удасться только после перезагрузки компьютера (по крайней мере у
    //меня это было так). В коде далее такая ситуация предотвращается.
    if Sender = ButtonWP then
    If ShowState = SW_HIDE then
    begin
      Add('Не рекомендуется запуск WordPad с флагом SW_HIDE. ' +
      'Запуск проигнорирован.');
      exit;
    end
    else
    ShellExecuteValue:=ShellExecute (Handle,
                                     Nil,
                                     'wordpad', //приложение (WordPad.exe)
                                     'TestFile.txt',//параметр коммандной
                                     //строки (здесь - имя файла)
                                     'test_folder', //папка по-умолчанию
                                     //в данном примере находится в рабочем
                                     //каталоге программы
                                     ShowState);

    //открытие текстового файла в программе, зарегистрированной в ОС для этого
    //типа файлов (обычно это Блокнот).
    if Sender = ButtonTextFile then
    ShellExecuteValue:=ShellExecute (Handle,
                                     Nil,
                                     'TestFile.txt',
                                     Nil,
                                     'test_folder',
                                     ShowState);

    //вариант открытия локального html-файла.
    //у меня изменение флага не имело значения.
    if Sender = ButtonHtmlFile then
    ShellExecuteValue:=ShellExecute (Handle,
                                     'open',
                                     'test_folder\htmlFile.html',
                                     Nil,
                                     Nil,
                                     ShowState);

    //открытие интернет-адреса в браузере по-умолчанию. Флаг у меня не имел
    //значения.
    if Sender = ButtonWeb then
    ShellExecuteValue:=ShellExecute (Handle,
                                     Nil,
                                     'http://somesite.some',//некий сайт
                                     Nil,
                                     Nil,
                                     ShowState);

    //вариант запуска почтовой программы по-умолчанию с темой сообщения. Флаг
    //у меня игнорировался.
    if Sender = ButtonEMail then
    ShellExecuteValue:=ShellExecute (Handle,
                                     Nil,
                                     'mailto:some@some.some?subject=тема',
                                     Nil,
                                     Nil,
                                     ShowState);
    //Add(IntToStr(getlasterror));
    Add('ShellExecute()...');
    If ShellExecuteValue > 32
    then Add('OK (вернулось ' + IntToStr(ShellExecuteValue) + ')') {успех}
    else Add(ErrorCodeToDescript(ShellExecuteValue));{ошибка при < = 32}
  end;
//ЗАМЕЧАНИЕ:
//можно в примере использовать и ShellExecuteA(), которая тоже описана в
//windows. Эти функции эквивалентны и являются Ansi-вариантом ShellExecute().
//Вариант для Unicode - ShellExecuteW().
end;



initialization
  {$i Main.lrs}

end.
