unit ShellExecuteUnit;    

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//                  API- ShellExecute()               //
//                         1.50 beta, . 2010                         //
//                           ( Delphi  Lazarus)                           //
// ..                                                                //
//sadovoya@mtu-net.ru                                                         //
//                                                                            //
//                                                                //
////////////////////////////////////////////////////////////////////////////////

interface

//---------------------------    ----------------------------------
//         - ShellExecute().
//     dll-.     
// -      Windows
// ShellApi   uses.    ,    "
//",    .  ,   
//   .       "",
//    .
//------------------------------------------------------------------------------


{-------------------------------------------------------------------------------
  API- ShellExecute()    .

  (  C++) :

HINSTANCE ShellExecute(
    HWND hwnd,
    LPCTSTR lpOperation,
    LPCTSTR lpFile,
    LPCTSTR lpParameters,
    LPCTSTR lpDirectory,
    INT nShowCmd
);

hwnd -   (   ).    
       "Handle"   (  ).    
         ,     .
lpOperation -   - ,   
                -,  ,  
              .      
                .  ,   ,  
                  .   
               :
                edit -      
                       .   lpFile (. ) 
                        -,     .
                explore -   ,  lpFile.
                find -  ,    .
                open -  ,   lpFile.  
                        ,   .
                print -  -,   lpFile. 
                         lpFile   -,   
                          .
                NULL - 1)   Microsoft Windows 2000:
                         -,    
                         .  ,   "open".
                       2) Windows 2000    :
                           -.
                           "open".   
                       ,       
                        .
                       <:  Pascal  NULL  Nil>
lpFile -   - ,    
         ,      .  
             (Shell namespace)  
            .  ,   
            . ,   
            "print".
lpParameters -    lpFile   ,  lpParameters -
                 - ,  
               ,    .   
                 .
                lpFile  -,  lpParameters 
                NULL.
               <:  Pascal  NULL  Nil>
lpDirectory -   - ,   
              -.
nShowCmd - ,       . 
            lpFile  -,    
            ,  ,   .

<  .     >.

 :
      > 32,
 -   (<=32).

<  .    >.

:
         
  .

 lpOperation NULL ( Pascal - Nil),   ,  lpFile.
 lpOperation "open"  "explore",     
.

Windows 95/98/Me: ShellExecute  Microsoft Layer  Unicode.
  ,      , 
   Microsoft Layer for Unicode on Windows 95/98/Me Systems.

   : Windows NT 3.1, Windows 95
-------------------------------------------------------------------------------}

const

//--------------------,  ShellExecute()------------------------
//      Windows   uses.
//
SW_HIDE = 0; //    .
SW_SHOWNORMAL = 1; //   .    
                   //,     
                   //   .  
                   //  ,    
                   //  .
SW_SHOWMINIMIZED = 2; //    .
SW_SHOWMAXIMIZED = 3; //---------------------------- .
SW_SHOWNOACTIVATE = 4; //       .
                       //   .
SW_SHOW = 5; //         
             //.
SW_MAXIMIZE = 3; //  .
SW_MINIMIZE = 6; //      
                 //    z-.
SW_RESTORE = 9; //   .    
                //, Windows     
                //  .    
                //,    .
SW_SHOWDEFAULT = 10; //     SW_ flag
                     // STARTUPINFO,   CreateProcess
                     //  .  
                     // ShowWindow   ,  
                     //     .
SW_SHOWMINNOACTIVE = 7; //  .  
                        // .
SW_SHOWNA = 8; //     .   
               //.

// : SW_SHOWMAXIMIZED = SW_MAXIMIZE - ,    ???
//------------------------------------------------------------------------------


//------------------- ,  ShellExecute()-------------------
//
//        
// Windows  ShellApi   uses.
//
//  :
//  0 - The operating system is out of memory or resources.
//

ERROR_FILE_NOT_FOUND =    2;  //  The specified file was not found.
                              //   ,  SE_ERR_FNF.
ERROR_PATH_NOT_FOUND =    3;  //  The specified path was not found.
                              //   ,  SE_ERR_PNF.
ERROR_BAD_FORMAT =       11;  //  The .exe file is invalid (non-Microsoft
                              //  Win32 .exe or error in .exe image).
SE_ERR_ACCESSDENIED =     5;  //  The operating system denied access to the
                              //  specified file.
SE_ERR_ASSOCINCOMPLETE = 27;  //  The file name association is incomplete or
                              //  invalid.
SE_ERR_DDEBUSY =         30;  //  The Dynamic Data Exchange (DDE) transaction
                              //  could not be completed because other DDE
                              //  transactions were being processed.
SE_ERR_DDEFAIL =         29;  //  The DDE transaction failed.
SE_ERR_DDETIMEOUT =      28;  //  The DDE transaction could not be completed
                              //  because the request timed out.
SE_ERR_DLLNOTFOUND =     32;  //  The specified dynamic-link library (DLL) was
                              //  not found.
SE_ERR_NOASSOC =         31;  //  There is no application associated with the
                              //  given file name extension. This error will
                              //  also be returned if you attempt to print a
                              //  file that is not printable.
SE_ERR_OOM =              8;  //  There was not enough memory to complete the
                              //  operation.
SE_ERR_SHARE =           26;  //  A sharing violation occurred.
//------------------------------------------------------------------------------


//--------------- ShellExecute()   ------------------
//
//    Pascal    :
//HINSTANCE, HWND - Cardinal
//LPCTSTR - PAnsiChar(=PChar)  PWideChar
//INT - Integer
//
//   .   :
// hWnd  hwnd,
// Operation - lpOperation,
// FileName - lpFile,
// Parameters - lpParameters,
// Directory - lpDirectory,
// ShowCmd - nShowCmd.

//Ansi-:
function ShellExecuteA(hWnd: Cardinal;
                      Operation, FileName, Parameters, Directory: PAnsiChar;
                      ShowCmd: Integer): Cardinal; stdcall;
external 'Shell32.dll' name 'ShellExecuteA';

//Unicode-:
function ShellExecuteW(hWnd: Cardinal;
                       Operation, FileName, Parameters, Directory: PWideChar;
                       ShowCmd: Integer): Cardinal; stdcall;
external 'Shell32.dll' name 'ShellExecuteW';  

//  Delphi:      shellapi  
//USES ,    .      
//ShellExecute(),   ShellExecuteA()
//
//  Lazarus:      windows  
//USES ,    .
//------------------------------------------------------------------------------

function ErrorCodeToDescript(ErrorCode: Cardinal):String;
//       ErrorCode.
// ErrorCode   ,   ShellExecute 
//  (  ).
//   ,   <= 32,    
//( "Unknown error.").
//  > 32,    ( "No errors.").


implementation

function ErrorCodeToDescript(ErrorCode: Cardinal):String;
begin
 Result := 'No errors.';
 If ErrorCode > 32 then exit      // 
 else Result := 'Unknown error.'; // 
 case ErrorCode of
    0:                       Result:='The operating system is out of memory '
                             + 'or resources.';
    ERROR_FILE_NOT_FOUND:    Result:='The specified file was not found.';
    ERROR_PATH_NOT_FOUND:    Result:='The specified path was not found.';
    ERROR_BAD_FORMAT:        Result:='The .exe file is invalid (non-Microsoft '
                             + 'Win32 .exe or error in .exe image).';
    SE_ERR_ACCESSDENIED:     Result:='The operating system denied access to '
                             + 'the specified file.';
    SE_ERR_ASSOCINCOMPLETE:  Result:='The file name association is incomplete '
                             + 'or invalid.';
    SE_ERR_DDEBUSY:          Result:='The Dynamic Data Exchange (DDE) '
                             + 'transaction could not be completed because '
                             + 'other DDE transactions were being processed.';
    SE_ERR_DDEFAIL:          Result:='The DDE transaction failed.';
    SE_ERR_DDETIMEOUT:       Result:='The DDE transaction could not be '
                             + 'completed because the request timed out.';
    SE_ERR_DLLNOTFOUND:      Result:='The specified dynamic-link library (DLL) '
                             + 'was not found.';
    SE_ERR_NOASSOC:          Result:='There is no application associated with '
                             + 'the given file name extension. This error will '
                             + 'also be returned if you attempt to print a '
                             + 'file that is not printable.';
    SE_ERR_OOM:              Result:='There was not enough memory to complete '
                             + 'the operation.';
    SE_ERR_SHARE:            Result:='A sharing violation occurred.';
 end;
 Result := 'ERROR: ' + Result;
end;

end.
